// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AIS_StackOfLocal_HeaderFile
#define _AIS_StackOfLocal_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_AIS_LocalContext_HeaderFile
#include <Handle_AIS_LocalContext.hxx>
#endif
#ifndef _Handle_AIS_StackNodeOfStackOfLocal_HeaderFile
#include <Handle_AIS_StackNodeOfStackOfLocal.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class AIS_StackIteratorOfStackOfLocal;
class AIS_LocalContext;
class AIS_StackNodeOfStackOfLocal;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class AIS_StackOfLocal  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT AIS_StackOfLocal();


Standard_EXPORT  const AIS_StackOfLocal& Assign(const AIS_StackOfLocal& Other) ;
 const AIS_StackOfLocal& operator =(const AIS_StackOfLocal& Other) 
{
  return Assign(Other);
}


  Standard_Boolean IsEmpty() const;

  Standard_Integer Depth() const;


Standard_EXPORT  const Handle_AIS_LocalContext& Top() const;


Standard_EXPORT   void Push(const Handle(AIS_LocalContext)& I) ;


Standard_EXPORT   void Pop() ;


Standard_EXPORT   void Clear() ;
~AIS_StackOfLocal()
{
  Clear();
}



Standard_EXPORT   Handle_AIS_LocalContext& ChangeTop() ;


friend class AIS_StackIteratorOfStackOfLocal;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT AIS_StackOfLocal(const AIS_StackOfLocal& Other);


 // Fields PRIVATE
 //
Standard_Address myTop;
Standard_Integer myDepth;


};

#define Item Handle_AIS_LocalContext
#define Item_hxx <AIS_LocalContext.hxx>
#define TCollection_StackNode AIS_StackNodeOfStackOfLocal
#define TCollection_StackNode_hxx <AIS_StackNodeOfStackOfLocal.hxx>
#define TCollection_StackIterator AIS_StackIteratorOfStackOfLocal
#define TCollection_StackIterator_hxx <AIS_StackIteratorOfStackOfLocal.hxx>
#define Handle_TCollection_StackNode Handle_AIS_StackNodeOfStackOfLocal
#define TCollection_StackNode_Type_() AIS_StackNodeOfStackOfLocal_Type_()
#define TCollection_Stack AIS_StackOfLocal
#define TCollection_Stack_hxx <AIS_StackOfLocal.hxx>

#include <TCollection_Stack.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_StackNode
#undef TCollection_StackNode_hxx
#undef TCollection_StackIterator
#undef TCollection_StackIterator_hxx
#undef Handle_TCollection_StackNode
#undef TCollection_StackNode_Type_
#undef TCollection_Stack
#undef TCollection_Stack_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
