// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MeshVS_VectorPrsBuilder_HeaderFile
#define _MeshVS_VectorPrsBuilder_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_MeshVS_VectorPrsBuilder_HeaderFile
#include <Handle_MeshVS_VectorPrsBuilder.hxx>
#endif

#ifndef _MeshVS_DataMapOfIntegerVector_HeaderFile
#include <MeshVS_DataMapOfIntegerVector.hxx>
#endif
#ifndef _MeshVS_PrsBuilder_HeaderFile
#include <MeshVS_PrsBuilder.hxx>
#endif
#ifndef _Handle_MeshVS_Mesh_HeaderFile
#include <Handle_MeshVS_Mesh.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _MeshVS_DisplayModeFlags_HeaderFile
#include <MeshVS_DisplayModeFlags.hxx>
#endif
#ifndef _Handle_MeshVS_DataSource_HeaderFile
#include <Handle_MeshVS_DataSource.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _MeshVS_BuilderPriority_HeaderFile
#include <MeshVS_BuilderPriority.hxx>
#endif
#ifndef _Handle_Prs3d_Presentation_HeaderFile
#include <Handle_Prs3d_Presentation.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Graphic3d_ArrayOfPrimitives_HeaderFile
#include <Handle_Graphic3d_ArrayOfPrimitives.hxx>
#endif
class MeshVS_Mesh;
class Quantity_Color;
class MeshVS_DataSource;
class Prs3d_Presentation;
class MeshVS_Array1OfIntegerBoolean;
class gp_Trsf;
class TColgp_Array1OfPnt;
class Graphic3d_ArrayOfPrimitives;
class MeshVS_DataMapOfIntegerVector;
class gp_Vec;


//! This class provides methods to create vector data presentation. <br>
//! It store map of vectors assigned with nodes or elements. <br>
class MeshVS_VectorPrsBuilder : public MeshVS_PrsBuilder {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT MeshVS_VectorPrsBuilder(const Handle(MeshVS_Mesh)& Parent,const Standard_Real MaxLength,const Quantity_Color& VectorColor,const MeshVS_DisplayModeFlags& Flags = MeshVS_DMF_VectorDataPrs,const Handle(MeshVS_DataSource)& DS = 0,const Standard_Integer Id = -1,const MeshVS_BuilderPriority& Priority = MeshVS_BP_Vector);

//! Builds vector data presentation <br>
Standard_EXPORT virtual  void Build(const Handle(Prs3d_Presentation)& Prs,MeshVS_Array1OfIntegerBoolean& IDs,const Standard_Boolean IsElement,const Standard_Integer theDisplayMode) const;

//! Adds to array of polygons and polylines some primitive representing single vector <br>
Standard_EXPORT   void DrawVector(const gp_Trsf& theTrsf,const Standard_Real Length,const TColgp_Array1OfPnt& ArrowPoints,const Handle(Graphic3d_ArrayOfPrimitives)& Lines,const Handle(Graphic3d_ArrayOfPrimitives)& Triangles) const;

//! Calculates points of arrow presentation <br>
Standard_EXPORT static  Standard_Real calculateArrow(TColgp_Array1OfPnt& Points,const Standard_Real Length,const Standard_Real ArrowPart) ;

//! Returns map of vectors assigned with nodes or elements <br>
Standard_EXPORT  const MeshVS_DataMapOfIntegerVector& GetVectors(const Standard_Boolean IsElement) const;

//! Sets map of vectors assigned with nodes or elements <br>
Standard_EXPORT   void SetVectors(const Standard_Boolean IsElement,const MeshVS_DataMapOfIntegerVector& Map) ;

//! Returns true, if map isn't empty <br>
Standard_EXPORT   Standard_Boolean HasVectors(const Standard_Boolean IsElement) const;

//! Returns vector assigned with certain node or element <br>
Standard_EXPORT   Standard_Boolean GetVector(const Standard_Boolean IsElement,const Standard_Integer ID,gp_Vec& Vect) const;

//! Sets vector assigned with certain node or element <br>
Standard_EXPORT   void SetVector(const Standard_Boolean IsElement,const Standard_Integer ID,const gp_Vec& Vect) ;

//! Calculates minimal and maximal length of vectors in map <br>
//! ( nodal, if IsElement = False or elemental, if IsElement = True ) <br>
Standard_EXPORT   void GetMinMaxVectorValue(const Standard_Boolean IsElement,Standard_Real& MinValue,Standard_Real& MaxValue) const;
//Standard_EXPORT ~MeshVS_VectorPrsBuilder();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
MeshVS_DataMapOfIntegerVector myNodeVectorMap;
MeshVS_DataMapOfIntegerVector myElemVectorMap;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
