// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TColStd_AVLSearchTreeOfInteger_HeaderFile
#define _TColStd_AVLSearchTreeOfInteger_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _TCollection_CompareOfInteger_HeaderFile
#include <TCollection_CompareOfInteger.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TColStd_AVLListOfAVLSearchTreeOfInteger_HeaderFile
#include <Handle_TColStd_AVLListOfAVLSearchTreeOfInteger.hxx>
#endif
#ifndef _Handle_TColStd_AVLNodeOfAVLSearchTreeOfInteger_HeaderFile
#include <Handle_TColStd_AVLNodeOfAVLSearchTreeOfInteger.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TCollection_Side_HeaderFile
#include <TCollection_Side.hxx>
#endif
class Standard_NoSuchObject;
class Standard_NoMoreObject;
class TColStd_AVLIteratorOfAVLSearchTreeOfInteger;
class TCollection_CompareOfInteger;
class TColStd_AVLListOfAVLSearchTreeOfInteger;
class TColStd_AVLNodeOfAVLSearchTreeOfInteger;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TColStd_AVLSearchTreeOfInteger  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TColStd_AVLSearchTreeOfInteger(const TCollection_CompareOfInteger& aComparator);

  Standard_Boolean IsEmpty() const;


Standard_EXPORT   Standard_Integer Extent() const;


Standard_EXPORT   Standard_Integer TotalExtent() const;


Standard_EXPORT   Standard_Boolean Find(const Standard_Integer& theItem) const;


Standard_EXPORT   Standard_Boolean Find(const Standard_Integer& theItem,Standard_Integer& theOrig) const;

  Standard_Address GetRoot() const;

  TCollection_CompareOfInteger GetComparator() const;


Standard_EXPORT   void Insert(const Standard_Integer& theItem) ;


Standard_EXPORT   Standard_Boolean InsertOnce(const Standard_Integer& theItem) ;


Standard_EXPORT   void Remove(const Standard_Integer& theItem) ;


Standard_EXPORT   void RemoveAll(const Standard_Integer& theItem) ;


Standard_EXPORT   TColStd_AVLSearchTreeOfInteger Merge(const TColStd_AVLSearchTreeOfInteger& another) const;


Standard_EXPORT   TColStd_AVLSearchTreeOfInteger ShallowCopy() const;


friend class TColStd_AVLIteratorOfAVLSearchTreeOfInteger;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

  void SetRoot(const Standard_Address theNode) ;


Standard_EXPORT   void RotateLeft(Standard_Address& theNode) const;


Standard_EXPORT   void RotateRight(Standard_Address& theNode) const;


Standard_EXPORT   void LeftBalance(Standard_Address& theNode) const;


Standard_EXPORT   void RightBalance(Standard_Address& theNode) const;


Standard_EXPORT   Standard_Boolean InsertBalance(Standard_Address& theNode,const Standard_Address theFather,const TCollection_Side theSide) const;


Standard_EXPORT   Standard_Boolean RemoveBalance(Standard_Address& theNode,const Standard_Address theFather,const TCollection_Side theSide) const;


Standard_EXPORT   Standard_Boolean RecursiveInsert(Standard_Address& theNode,const Standard_Address theFather,const TCollection_Side theSide,const Standard_Integer& theItem,Standard_Boolean& forOnce) const;


Standard_EXPORT   Standard_Boolean Find(const Standard_Integer& theItem,Standard_Address& theNode) const;


Standard_EXPORT   Standard_Boolean RecursiveRemove(Standard_Address& theNode,const Standard_Address theFather,const TCollection_Side theSide,const Standard_Integer& theItem,const Standard_Boolean forAll) const;


 // Fields PRIVATE
 //
Standard_Address TheRoot;
TCollection_CompareOfInteger TheComparator;


};

#define Item Standard_Integer
#define Item_hxx <Standard_Integer.hxx>
#define Comparator TCollection_CompareOfInteger
#define Comparator_hxx <TCollection_CompareOfInteger.hxx>
#define TCollection_AVLList TColStd_AVLListOfAVLSearchTreeOfInteger
#define TCollection_AVLList_hxx <TColStd_AVLListOfAVLSearchTreeOfInteger.hxx>
#define TCollection_AVLNode TColStd_AVLNodeOfAVLSearchTreeOfInteger
#define TCollection_AVLNode_hxx <TColStd_AVLNodeOfAVLSearchTreeOfInteger.hxx>
#define TCollection_AVLIterator TColStd_AVLIteratorOfAVLSearchTreeOfInteger
#define TCollection_AVLIterator_hxx <TColStd_AVLIteratorOfAVLSearchTreeOfInteger.hxx>
#define Handle_TCollection_AVLList Handle_TColStd_AVLListOfAVLSearchTreeOfInteger
#define TCollection_AVLList_Type_() TColStd_AVLListOfAVLSearchTreeOfInteger_Type_()
#define Handle_TCollection_AVLNode Handle_TColStd_AVLNodeOfAVLSearchTreeOfInteger
#define TCollection_AVLNode_Type_() TColStd_AVLNodeOfAVLSearchTreeOfInteger_Type_()
#define TCollection_AVLSearchTree TColStd_AVLSearchTreeOfInteger
#define TCollection_AVLSearchTree_hxx <TColStd_AVLSearchTreeOfInteger.hxx>

#include <TCollection_AVLSearchTree.lxx>

#undef Item
#undef Item_hxx
#undef Comparator
#undef Comparator_hxx
#undef TCollection_AVLList
#undef TCollection_AVLList_hxx
#undef TCollection_AVLNode
#undef TCollection_AVLNode_hxx
#undef TCollection_AVLIterator
#undef TCollection_AVLIterator_hxx
#undef Handle_TCollection_AVLList
#undef TCollection_AVLList_Type_
#undef Handle_TCollection_AVLNode
#undef TCollection_AVLNode_Type_
#undef TCollection_AVLSearchTree
#undef TCollection_AVLSearchTree_hxx


// other Inline functions and methods (like "C++: function call" methods)
//
inline TColStd_AVLSearchTreeOfInteger ShallowCopy(const TColStd_AVLSearchTreeOfInteger& me) {
 return me.ShallowCopy();
}



#endif
