// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TColStd_AVLSearchTreeOfReal_HeaderFile
#define _TColStd_AVLSearchTreeOfReal_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _TCollection_CompareOfReal_HeaderFile
#include <TCollection_CompareOfReal.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_TColStd_AVLListOfAVLSearchTreeOfReal_HeaderFile
#include <Handle_TColStd_AVLListOfAVLSearchTreeOfReal.hxx>
#endif
#ifndef _Handle_TColStd_AVLNodeOfAVLSearchTreeOfReal_HeaderFile
#include <Handle_TColStd_AVLNodeOfAVLSearchTreeOfReal.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _TCollection_Side_HeaderFile
#include <TCollection_Side.hxx>
#endif
class Standard_NoSuchObject;
class Standard_NoMoreObject;
class TColStd_AVLIteratorOfAVLSearchTreeOfReal;
class TCollection_CompareOfReal;
class TColStd_AVLListOfAVLSearchTreeOfReal;
class TColStd_AVLNodeOfAVLSearchTreeOfReal;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TColStd_AVLSearchTreeOfReal  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TColStd_AVLSearchTreeOfReal(const TCollection_CompareOfReal& aComparator);

  Standard_Boolean IsEmpty() const;


Standard_EXPORT   Standard_Integer Extent() const;


Standard_EXPORT   Standard_Integer TotalExtent() const;


Standard_EXPORT   Standard_Boolean Find(const Standard_Real& theItem) const;


Standard_EXPORT   Standard_Boolean Find(const Standard_Real& theItem,Standard_Real& theOrig) const;

  Standard_Address GetRoot() const;

  TCollection_CompareOfReal GetComparator() const;


Standard_EXPORT   void Insert(const Standard_Real& theItem) ;


Standard_EXPORT   Standard_Boolean InsertOnce(const Standard_Real& theItem) ;


Standard_EXPORT   void Remove(const Standard_Real& theItem) ;


Standard_EXPORT   void RemoveAll(const Standard_Real& theItem) ;


Standard_EXPORT   TColStd_AVLSearchTreeOfReal Merge(const TColStd_AVLSearchTreeOfReal& another) const;


Standard_EXPORT   TColStd_AVLSearchTreeOfReal ShallowCopy() const;


friend class TColStd_AVLIteratorOfAVLSearchTreeOfReal;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

  void SetRoot(const Standard_Address theNode) ;


Standard_EXPORT   void RotateLeft(Standard_Address& theNode) const;


Standard_EXPORT   void RotateRight(Standard_Address& theNode) const;


Standard_EXPORT   void LeftBalance(Standard_Address& theNode) const;


Standard_EXPORT   void RightBalance(Standard_Address& theNode) const;


Standard_EXPORT   Standard_Boolean InsertBalance(Standard_Address& theNode,const Standard_Address theFather,const TCollection_Side theSide) const;


Standard_EXPORT   Standard_Boolean RemoveBalance(Standard_Address& theNode,const Standard_Address theFather,const TCollection_Side theSide) const;


Standard_EXPORT   Standard_Boolean RecursiveInsert(Standard_Address& theNode,const Standard_Address theFather,const TCollection_Side theSide,const Standard_Real& theItem,Standard_Boolean& forOnce) const;


Standard_EXPORT   Standard_Boolean Find(const Standard_Real& theItem,Standard_Address& theNode) const;


Standard_EXPORT   Standard_Boolean RecursiveRemove(Standard_Address& theNode,const Standard_Address theFather,const TCollection_Side theSide,const Standard_Real& theItem,const Standard_Boolean forAll) const;


 // Fields PRIVATE
 //
Standard_Address TheRoot;
TCollection_CompareOfReal TheComparator;


};

#define Item Standard_Real
#define Item_hxx <Standard_Real.hxx>
#define Comparator TCollection_CompareOfReal
#define Comparator_hxx <TCollection_CompareOfReal.hxx>
#define TCollection_AVLList TColStd_AVLListOfAVLSearchTreeOfReal
#define TCollection_AVLList_hxx <TColStd_AVLListOfAVLSearchTreeOfReal.hxx>
#define TCollection_AVLNode TColStd_AVLNodeOfAVLSearchTreeOfReal
#define TCollection_AVLNode_hxx <TColStd_AVLNodeOfAVLSearchTreeOfReal.hxx>
#define TCollection_AVLIterator TColStd_AVLIteratorOfAVLSearchTreeOfReal
#define TCollection_AVLIterator_hxx <TColStd_AVLIteratorOfAVLSearchTreeOfReal.hxx>
#define Handle_TCollection_AVLList Handle_TColStd_AVLListOfAVLSearchTreeOfReal
#define TCollection_AVLList_Type_() TColStd_AVLListOfAVLSearchTreeOfReal_Type_()
#define Handle_TCollection_AVLNode Handle_TColStd_AVLNodeOfAVLSearchTreeOfReal
#define TCollection_AVLNode_Type_() TColStd_AVLNodeOfAVLSearchTreeOfReal_Type_()
#define TCollection_AVLSearchTree TColStd_AVLSearchTreeOfReal
#define TCollection_AVLSearchTree_hxx <TColStd_AVLSearchTreeOfReal.hxx>

#include <TCollection_AVLSearchTree.lxx>

#undef Item
#undef Item_hxx
#undef Comparator
#undef Comparator_hxx
#undef TCollection_AVLList
#undef TCollection_AVLList_hxx
#undef TCollection_AVLNode
#undef TCollection_AVLNode_hxx
#undef TCollection_AVLIterator
#undef TCollection_AVLIterator_hxx
#undef Handle_TCollection_AVLList
#undef TCollection_AVLList_Type_
#undef Handle_TCollection_AVLNode
#undef TCollection_AVLNode_Type_
#undef TCollection_AVLSearchTree
#undef TCollection_AVLSearchTree_hxx


// other Inline functions and methods (like "C++: function call" methods)
//
inline TColStd_AVLSearchTreeOfReal ShallowCopy(const TColStd_AVLSearchTreeOfReal& me) {
 return me.ShallowCopy();
}



#endif
