/* MA1CNT.f -- translated by f2c (version 19960827).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "Data_f2c.h"

/* Subroutine */ int mma1cnt_(ndimen, iordre, contr1, contr2, hermit, ndgjac, 
	crvjac)
integer *ndimen, *iordre;
doublereal *contr1, *contr2, *hermit;
integer *ndgjac;
doublereal *crvjac;
{
    /* System generated locals */
    integer contr1_dim1, contr1_offset, contr2_dim1, contr2_offset, 
	    hermit_dim1, hermit_offset, crvjac_dim1, crvjac_offset, i__1, 
	    i__2, i__3;

    /* Local variables */
    static integer nd, ii, jj, ibb;
    static doublereal bid;
    extern integer mnfndeb_();
    extern /* Subroutine */ int mgenmsg_(), mgsomsg_();



/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*     Ajout du polynome de contrainte. */

/*     MOTS CLES : */
/*     ----------- */
/*     TOUS,AB_SPECIFI::COURE&,APPROXIMATION,ADDITION,&CONTRAINTE */

/*     ARGUMENTS D'ENTREE : */
/*     -------------------- */
/*     NDIMEN: Dimension de l'espace */
/*     IORDRE: Ordre de contrainte. */
/*     CONTR1: pt de contrainte en -1, de l'ordre 0 a IORDRE. */
/*     CONTR2: Pt de contrainte en +1, de l'ordre 0 a IORDRE. */
/*     HERMIT: Table des polynomes d'hermite d'ordre IORDRE. */
/*     CRVJAV: Courbe d'approximation dans la base de Jacobi. */

/*     ARGUMENTS DE SORTIE : */
/*     --------------------- */
/*     CRVJAV: Courbe d'approximation dans la base de Jacobi */
/*             a laquelle on a ajoute le polynome d'interpolation des */
/*             contraintes. */

/*     COMMONS UTILISES : */
/*     ------------------ */


/*     REFERENCES APPELEES : */
/*     --------------------- */


/*     DESCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */


/* $    HISTORIQUE DES MODIFICATIONS : */
/*     ------------------------------ */
/*     07-08-91:RBD; Ecriture version originale. */
/* > */
/* ***********************************************************************
 */
/*                            DECLARATIONS */
/* ***********************************************************************
 */
/*   Le nom de la routine */

/* ***********************************************************************
 */
/*                         INITIALISATIONS */
/* ***********************************************************************
 */

    /* Parameter adjustments */
    hermit_dim1 = (*iordre << 1) + 2;
    hermit_offset = hermit_dim1;
    hermit -= hermit_offset;
    contr2_dim1 = *ndimen;
    contr2_offset = contr2_dim1 + 1;
    contr2 -= contr2_offset;
    contr1_dim1 = *ndimen;
    contr1_offset = contr1_dim1 + 1;
    contr1 -= contr1_offset;
    crvjac_dim1 = *ndgjac + 1;
    crvjac_offset = crvjac_dim1;
    crvjac -= crvjac_offset;

    /* Function Body */
    ibb = mnfndeb_();
    if (ibb >= 3) {
	mgenmsg_("MMA1CNT", 7L);
    }

/* ***********************************************************************
 */
/*                            TRAITEMENT */
/* ***********************************************************************
 */

    i__1 = *ndimen;
    for (nd = 1; nd <= i__1; ++nd) {
	i__2 = (*iordre << 1) + 1;
	for (ii = 0; ii <= i__2; ++ii) {
	    bid = 0.;
	    i__3 = *iordre + 1;
	    for (jj = 1; jj <= i__3; ++jj) {
		bid = bid + contr1[nd + jj * contr1_dim1] * hermit[ii + ((jj 
			<< 1) - 1) * hermit_dim1] + contr2[nd + jj * 
			contr2_dim1] * hermit[ii + (jj << 1) * hermit_dim1];
/* L300: */
	    }
	    crvjac[ii + nd * crvjac_dim1] = bid;
/* L200: */
	}
/* L100: */
    }

/* ***********************************************************************
 */
/*                   RETOUR PROGRAMME APPELANT */
/* ***********************************************************************
 */

    if (ibb >= 3) {
	mgsomsg_("MMA1CNT", 7L);
    }

  return 0 ;
} /* mma1cnt_ */

