/* MJACPT.f -- translated by f2c (version 19960827).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "Data_f2c.h"

/* Subroutine */ int mmjacpt_(ndimen, ncoefu, ncoefv, iordru, iordrv, ptclgd, 
	ptcaux, ptccan)
integer *ndimen, *ncoefu, *ncoefv, *iordru, *iordrv;
doublereal *ptclgd, *ptcaux, *ptccan;
{
    /* System generated locals */
    integer ptccan_dim1, ptccan_dim2, ptccan_offset, ptclgd_dim1, ptclgd_dim2,
	     ptclgd_offset, ptcaux_dim1, ptcaux_dim2, ptcaux_dim3, 
	    ptcaux_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer kdim, nd, ii, jj, ibb;
    extern integer mnfndeb_();
    extern /* Subroutine */ int mmjaccv_(), mgenmsg_(), mgsomsg_();



/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*        Passage de la base canonique a la base de Jacobi pour */
/*        un "carreau" dans un espace de dimension qcq. */

/*     MOTS CLES : */
/*     ----------- */
/*        LISSAGE,BASE,LEGENDRE */


/*     ARGUMENTS D'ENTREE : */
/*     ------------------ */
/*        NDIMEN   : Dimension de l' espace. */
/*        NCOEFU : Degre+1 en U. */
/*        NCOEFV : Degre+1 en V. */
/*        IORDRU : Ordre des polynomes de Jacobi en U. */
/*        IORDRV : Ordre des polynomes de Jacobi en V. */
/*        PTCLGD : Le carreau dans la base de Jacobi. */

/*     ARGUMENTS DE SORTIE : */
/*     ------------------- */
/*        PTCAUX : Espace auxilliaire. */
/*        PTCCAN : Le carreau dans la base canonique (-1,1) */

/*     COMMONS UTILISES   : */
/*     ---------------- */

/*     REFERENCES APPELEES   : */
/*     ----------------------- */

/*     DESCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */
/*     Annule et remplace MJACPC */

/* $    HISTORIQUE DES MODIFICATIONS   : */
/*     -------------------------------- */
/*     03-08-1989 : RBD; Creation. */
/* > */
/* ********************************************************************* 
*/
/*   Le nom de la routine */


    /* Parameter adjustments */
    ptccan_dim1 = *ncoefu;
    ptccan_dim2 = *ncoefv;
    ptccan_offset = ptccan_dim1 * (ptccan_dim2 + 1) + 1;
    ptccan -= ptccan_offset;
    ptcaux_dim1 = *ncoefv;
    ptcaux_dim2 = *ncoefu;
    ptcaux_dim3 = *ndimen;
    ptcaux_offset = ptcaux_dim1 * (ptcaux_dim2 * (ptcaux_dim3 + 1) + 1) + 1;
    ptcaux -= ptcaux_offset;
    ptclgd_dim1 = *ncoefu;
    ptclgd_dim2 = *ncoefv;
    ptclgd_offset = ptclgd_dim1 * (ptclgd_dim2 + 1) + 1;
    ptclgd -= ptclgd_offset;

    /* Function Body */
    ibb = mnfndeb_();
    if (ibb >= 3) {
	mgenmsg_("MMJACPT", 7L);
    }

/*   Passage dans canonique en u. */

    kdim = *ndimen * *ncoefv;
    mmjaccv_(ncoefu, &kdim, iordru, &ptclgd[ptclgd_offset], &ptcaux[
	    ptcaux_offset], &ptccan[ptccan_offset]);

/*   Permutation des u et des v. */

    i__1 = *ndimen;
    for (nd = 1; nd <= i__1; ++nd) {
	i__2 = *ncoefv;
	for (jj = 1; jj <= i__2; ++jj) {
	    i__3 = *ncoefu;
	    for (ii = 1; ii <= i__3; ++ii) {
		ptcaux[jj + (ii + (nd + ptcaux_dim3) * ptcaux_dim2) * 
			ptcaux_dim1] = ptccan[ii + (jj + nd * ptccan_dim2) * 
			ptccan_dim1];
/* L320: */
	    }
/* L310: */
	}
/* L300: */
    }

/*   Passage dans canonique en v. */

    kdim = *ndimen * *ncoefu;
    mmjaccv_(ncoefv, &kdim, iordrv, &ptcaux[((ptcaux_dim3 + 1) * ptcaux_dim2 
	    + 1) * ptcaux_dim1 + 1], &ptccan[ptccan_offset], &ptcaux[(((
	    ptcaux_dim3 << 1) + 1) * ptcaux_dim2 + 1) * ptcaux_dim1 + 1]);

/*   Permutation des u et des v. */

    i__1 = *ndimen;
    for (nd = 1; nd <= i__1; ++nd) {
	i__2 = *ncoefv;
	for (jj = 1; jj <= i__2; ++jj) {
	    i__3 = *ncoefu;
	    for (ii = 1; ii <= i__3; ++ii) {
		ptccan[ii + (jj + nd * ptccan_dim2) * ptccan_dim1] = ptcaux[
			jj + (ii + (nd + (ptcaux_dim3 << 1)) * ptcaux_dim2) * 
			ptcaux_dim1];
/* L420: */
	    }
/* L410: */
	}
/* L400: */
    }

/* ---------------------------- THAT'S ALL FOLKS ------------------------ 
*/

    if (ibb >= 3) {
	mgsomsg_("MMJACPT", 7L);
    }
    return 0;
} /* mmjacpt_ */

