/* MATVEC.f -- translated by f2c (version 19960827).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "Data_f2c.h"

/* Subroutine */ int mmatvec_(nligne, ncolon, gposit, gnstoc, gmatri, vecin, 
	deblig, vecout, iercod)
integer *nligne, *ncolon, *gposit, *gnstoc;
doublereal *gmatri, *vecin;
integer *deblig;
doublereal *vecout;
integer *iercod;
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static logical ldbg;
    static integer jmin, jmax, i__, j, k;
    static doublereal somme;
    extern integer mnfndeb_();
    static integer aux;
    extern /* Subroutine */ int maermsg_(), mgenmsg_(), mgsomsg_(), mvriraz_()
	    ;



/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*      EFFECUE LE PRODUIT MATRICE VECTEUR OU LA MATRICE EST SOUS FORME */
/*      DE PROFIL */


/*     MOTS CLES : */
/*     ----------- */
/*      RESERVE, MATRICE, PRODUIT, VECTEUR, PROFIL */

/*     ARGUMENTS D'ENTREE : */
/*     -------------------- */
/*       NLIGNE : NOMBRE DE LIGNE DE LA MATRICE DES CONTRAINTES */
/*       NCOLON :NOMBRE DE COLONNE DE LA MATRICE DES CONTRAINTES */
/*       GNSTOC: NOMBRE DE COEFFICIENTS DANS LE PROFILE de la matrice */
/*               GMATRI */

/*       GPOSIT: TABLE DE POSITIONNEMENT DES TERMES DE STOCKAGE */
/*               GPOSIT(1,I) CONTIENT LE NOMBRE DE TERMES-1 SUR LA LIGNE 
*/
/*               I DANS LE PROFIL DE LA MATRICE */
/*              GPOSIT(2,I) CONTIENT L'INDICE DE STOCKAGE DU TERME DIAGONA
L*/
/*               DE LA LIGNE I */
/*               GPOSIT(3,I) CONTIENT L'INDICE COLONE DU PREMIER TERME DU 
*/
/*                           PROFIL DE LA LIGNE I */
/*       GNSTOC: NOMBRE DE COEFFICIENTS DANS LE PROFILE de la matrice */
/*               GMATRI */
/*       GMATRI : MATRICE DES CONTRAINTES SOUS FORME DE PROFIL */
/*       VECIN  : VECTEUR ENTRE */
/*       DEBLIG : INDICE DE LIGNE A PARTIR DUQUEL ON VEUT CALCULER */
/*                LE PRODUIT MATRICE VECTEUR */
/*     ARGUMENTS DE SORTIE : */
/*     --------------------- */
/*       VECOUT : VECTEUR PRODUIT */

/*       IERCOD : CODE D'ERREUR */


/*     COMMONS UTILISES : */
/*     ------------------ */


/*     REFERENCES APPELEES : */
/*     --------------------- */


/*     DESCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */


/* $    HISTORIQUE DES MODIFICATIONS : */
/*     ------------------------------ */
/*     22-09-95 : ...; ECRITURE VERSION ORIGINALE. */
/* > */
/* ***********************************************************************
 */
/*                            DECLARATIONS */
/* ***********************************************************************
 */



/* ***********************************************************************
 */
/*                      INITIALISATIONS */
/* ***********************************************************************
 */

    /* Parameter adjustments */
    --vecout;
    gposit -= 4;
    --vecin;
    --gmatri;

    /* Function Body */
    ldbg = mnfndeb_() >= 2;
    if (ldbg) {
	mgenmsg_("MMATVEC", 7L);
    }
    *iercod = 0;

/* ***********************************************************************
 */
/*                     TRAITEMENT */
/* ***********************************************************************
 */



    mvriraz_(nligne, &vecout[1]);
    i__1 = *nligne;
    for (i__ = *deblig; i__ <= i__1; ++i__) {
	somme = 0.;
	jmin = gposit[i__ * 3 + 3];
	jmax = gposit[i__ * 3 + 1] + gposit[i__ * 3 + 3] - 1;
	aux = gposit[i__ * 3 + 2] - gposit[i__ * 3 + 1] - jmin + 1;
	i__2 = jmax;
	for (j = jmin; j <= i__2; ++j) {
	    k = j + aux;
	    somme += gmatri[k] * vecin[j];
	}
	vecout[i__] = somme;
    }





    goto L9999;

/* ***********************************************************************
 */
/*                   TRAITEMENT DES ERREURS */
/* ***********************************************************************
 */




/* ***********************************************************************
 */
/*                   RETOUR PROGRAMME APPELANT */
/* ***********************************************************************
 */

L9999:

/* ___ DESALLOCATION, ... */

    maermsg_("MMATVEC", iercod, 7L);
    if (ldbg) {
	mgsomsg_("MMATVEC", 7L);
    }

 return 0 ;
} /* mmatvec_ */

