/* MEPS1.f -- translated by f2c (version 19960827).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "Data_f2c.h"
#ifdef WNT
#include <MathBase.h>
#else 
#define  __MathBase_API
#endif
/* Common Block Declarations */

extern struct {
    doublereal eps1, eps2, eps3, eps4;
    integer niterm, niterr;
} mmprcsn_;

#define mmprcsn_1 mmprcsn_

/* Subroutine */ __MathBase_API int mmeps1_(epsilo)
doublereal *epsilo;
{


/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*        Extraction du EPS1 du COMMON MPRCSN. EPS1 est le zero spatial */
/*     egal a 1.D-9 */

/*     MOTS CLES : */
/*     ----------- */
/*        MPRCSN,PRECISON,EPS1. */

/*     ARGUMENTS D'ENTREE : */
/*     ------------------ */
/*        Neant */

/*     ARGUMENTS DE SORTIE : */
/*     ------------------- */
/*        EPSILO : Valeur de EPS1 (Le zero spatial (10**-9)) */

/*     COMMONS UTILISES   : */
/*     ---------------- */

/*     REFERENCES APPELEES   : */
/*     ----------------------- */

/*     DESCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */
/*     EPS1 est le zero spatial ABSOLU , c.a.d. que l' on doit */
/*     l' utiliser chaque fois que l' on veut tester si une variable */
/*     est nulle. Par exemple, si la norme d' un vecteur est inferieure */
/*     a EPS1, c' est que ce vecteur est NUL ! (lorsqu' on travaille en */
/*     REAL*8) Il est vivement deconseille de tester des arguments par */
/*     rapport a EPS1**2. Vu les erreurs d' arrondis inevitables lors */
/*     des calculs, cela revient a tester par rapport a 0.D0. */

/* $    HISTORIQUE DES MODIFICATIONS   : */
/*     -------------------------------- */
/*     29-01-90 : DH ; Nettoyage */
/*     27-07-88 : RBD; Ajouts de commentaires. */
/*     29-10-87 : Cree par JJM. */
/* > */
/* ***********************************************************************
 */


/*     INCLUDE MPRCSN */
/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*          DONNE LES TOLERANCES DE NULLITE DANS STRIM */
/*          AINSI QUE LES BORNES DES PROCESSUS ITERATIFS */

/*          CONTEXTE GENERAL, MODIFIABLE PAR L'UTILISATEUR */

/*     MOTS CLES : */
/*     ----------- */
/*          PARAMETRE , TOLERANCE */

/*     DEMSCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */
/*       INITIALISATION   :  PROFIL , **VIA MPRFTX** A L' ENTREE DANS STRI
M*/

/*       CHARGEMENT DES VALEURS PAR DEFAUT DU PROFIL DANS MPRFTX A L'ENTRE
E*/
/*        DANS STRIM. ELLES SONT CONSERVEES DANS DES VARIABLES LOCALES */
/*        DE MPRFTX */

/*        REMISE DES VALEURS PAR DEFAUT                  : MDFINT */
/*        MODIFICATION INTERACTIVE  PAR L'UTILISATEUR    : MDBINT */

/*        FONCTION D'ACCES :  MMEPS1   ...  EPS1 */
/*                            MEPSPB  ...  EPS3,EPS4 */
/*                            MEPSLN  ...  EPS2, NITERM , NITERR */
/*                            MEPSNR  ...  EPS2 , NITERM */
/*                            MITERR  ...  NITERR */

/* $    HISTORIQUE DES MODIFICATIONS : */
/*     ------------------------------ */
/*      01-02-90 : NAK  ; ENTETE */
/* > */
/* ***********************************************************************
 */

/*     NITERM : NB D'ITERATIONS MAXIMAL */
/*     NITERR : NB D'ITERATIONS RAPIDES */
/*     EPS1   : TOLERANCE DE DISTANCE 3D NULLE */
/*     EPS2   : TOLERANCE DE DISTANCE PARAMETRIQUE NULLE */
/*     EPS3   : TOLERANCE POUR EVITER LES DIVISIONS PAR 0.. */
/*     EPS4   : TOLERANCE ANGULAIRE */



/* ***********************************************************************
 */
    *epsilo = mmprcsn_1.eps1;

 return 0 ;
} /* mmeps1_ */

