/* MFMCB5.f -- translated by f2c (version 19960827).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "Data_f2c.h"
#ifdef WNT
#include <MathBase.h>
#else 
#define  __MathBase_API
#endif

/* Subroutine */ int mmfmcb5_(isenmsc, ndimax, ncf1mx, courb1, ncoeff, ncf2mx,
	 ndimen, courb2, iercod)
integer *isenmsc, *ndimax, *ncf1mx;
doublereal *courb1;
integer *ncoeff, *ncf2mx, *ndimen;
doublereal *courb2;
integer *iercod;
{
    /* System generated locals */
    integer courb1_dim1, courb1_offset, courb2_dim1, courb2_offset, i__1, 
	    i__2;

    /* Local variables */
    static integer i__, nboct, nd;
    extern /* Subroutine */ int mcrfill_(), maermsg_();



/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ********************************************************************** 
*/

/*     FONCTION : */
/*     ---------- */
/*       Reformattage (et compactage/decompactage eventuel) de courbe */
/*       (ndim,.) en (.,ndim) et reciproquement . */

/*     MOTS CLES : */
/*     ----------- */
/*      TOUS , MATH_ACCES :: */
/*      COURBE&, REORGANISATION,COMPRESSION,INVERSION , &COURBE */

/*     ARGUMENTS D'ENTREE : */
/*     -------------------- */
/*        ISENMSC : sens du transfert demande : */
/*            1   :   passage de (NDIMEN,.) ---> (.,NDIMEN)  sens vers AB 
*/
/*          -1   :   passage de (.,NDIMEN) ---> (NDIMEN,.)  sens vers TS,T
V*/
/*        NDIMAX : format / dimension */
/*        NCF1MX : format en t de COURB1 */
/*   si ISENMSC= 1 : COURB1: La courbe a traiter (NDIMAX,.) */
/*        NCOEFF : nombre de coef de la courbe */
/*        NCF2MX : format en t de COURB2 */
/*        NDIMEN : dimension de la courbe et format de COURB2 */
/*   si ISENMSC=-1 : COURB2: La courbe a traiter (.,NDIMEN) */

/*     ARGUMENTS DE SORTIE : */
/*     --------------------- */
/*   si ISENMSC= 1 : COURB2: La courbe resultat (.,NDIMEN) */
/*   si ISENMSC=-1 : COURB1: La courbe resultat (NDIMAX,.) */

/*     COMMONS UTILISES : */
/*     ------------------ */

/*     REFERENCES APPELEES : */
/*     --------------------- */

/*     DESCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */
/*     permet de traiter les transferts usuels suivant : */
/*     | ---- ISENMSC = 1 ---- |      | ---- ISENMSC =-1 ----- | */
/*    TS  (3,21) --> (21,3)  AB  ;  AB  (21,3) --> (3,21)  TS */
/*    TS  (3,21) --> (NU,3)  AB  ;  AB  (NU,3) --> (3,21)  TS */
/*        (3,NU) --> (21,3)  AB  ;  AB  (21,3) --> (3,NU) */
/*        (3,NU) --> (NU,3)  AB  ;  AB  (NU,3) --> (3,NU) */

/* $    HISTORIQUE DES MODIFICATIONS : */
/*     ------------------------------ */
/*       .07-08-89 : JG ; VERSION ORIGINALE (ANNULE ET REMPLACE MMCVINV) 
*/
/* > */
/* ***********************************************************************
 */


    /* Parameter adjustments */
    courb1_dim1 = *ndimax;
    courb1_offset = courb1_dim1 + 1;
    courb1 -= courb1_offset;
    courb2_dim1 = *ncf2mx;
    courb2_offset = courb2_dim1 + 1;
    courb2 -= courb2_offset;

    /* Function Body */
    if (*ndimen > *ndimax || *ncoeff > *ncf1mx || *ncoeff > *ncf2mx) {
	goto L9119;
    }

    if (*ndimen == 1 && *ncf1mx == *ncf2mx) {
	nboct = *ncf2mx << 3;
	if (*isenmsc == 1) {
	    mcrfill_(&nboct, &courb1[courb1_offset], &courb2[courb2_offset]);
	}
	if (*isenmsc == -1) {
	    mcrfill_(&nboct, &courb2[courb2_offset], &courb1[courb1_offset]);
	}
	*iercod = -3136;
	goto L9999;
    }

    *iercod = 0;
    if (*isenmsc == 1) {
	i__1 = *ndimen;
	for (nd = 1; nd <= i__1; ++nd) {
	    i__2 = *ncoeff;
	    for (i__ = 1; i__ <= i__2; ++i__) {
		courb2[i__ + nd * courb2_dim1] = courb1[nd + i__ * 
			courb1_dim1];
/* L400: */
	    }
/* L500: */
	}
    } else if (*isenmsc == -1) {
	i__1 = *ndimen;
	for (nd = 1; nd <= i__1; ++nd) {
	    i__2 = *ncoeff;
	    for (i__ = 1; i__ <= i__2; ++i__) {
		courb1[nd + i__ * courb1_dim1] = courb2[i__ + nd * 
			courb2_dim1];
/* L1400: */
	    }
/* L1500: */
	}
    } else {
	*iercod = 3164;
    }

    goto L9999;

/* ***********************************************************************
 */

L9119:
    *iercod = 3119;

L9999:
    if (*iercod != 0) {
	maermsg_("MMFMCB5", iercod, 7L);
    }
    return 0;
} /* mmfmcb5_ */

