/* MHERM0.f -- translated by f2c (version 19960827).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "Data_f2c.h"

/* Common Block Declarations */

struct {
    doublereal tdebut, tfinal, verifi, cmherm[576]	/* was [6][3][2][4][4]
	     */;
} mmcmher_;

#define mmcmher_1 mmcmher_

/* Table of constant values */

static integer c__576 = 576;
static integer c__6 = 6;

/* Subroutine */ int mmherm0_(debfin, iercod)
doublereal *debfin;
integer *iercod;
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1;

    /* Local variables */
    static doublereal amat[36]	/* was [6][6] */;
    static integer iord[2];
    static doublereal prod;
    static integer iord1, iord2;
    extern /* Subroutine */ int mmmrslwd_();
    static doublereal miden[36]	/* was [6][6] */;
    static integer ncmat;
    static doublereal epspi, d1, d2;
    static integer ii, jj, pp, ncf;
    static doublereal cof[6];
    static integer iof[2], ier;
    static doublereal mat[36]	/* was [6][6] */;
    static integer cot;
    extern /* Subroutine */ int maermsg_(), mvriraz_();
    static doublereal abid[72]	/* was [12][6] */;




/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*      INIT DES COEFFS. DES POLYNOMES D'INTERPOL. D'HERMITE */

/*     MOTS CLES : */
/*     ----------- */
/*      MATH_ACCES :: HERMITE */

/*     ARGUMENTS D'ENTREE : */
/*     -------------------- */
/*       DEBFIN : PARAMETRES OU SONT DONNEES LES CONTRAINTES */
/*                 DEBFIN(1) : PREMIER PARAMETRE */
/*                 DEBFIN(2) : DEUXIEME PARAMETRE */

/*     ON DOIT AVOIR: */
/*                 ABS (DEBFIN(I)) < 100 */
/*                 et */
/*                 (ABS(DEBFIN(1)+ABS(DEBFIN(2))) > 1/100 */
/*           (pour les overflows) */

/*      ABS(DEBFIN(2)-DEBFIN(1)) / (ABS(DEBFIN(1)+ABS(DEBFIN(2))) > 1/100 
*/
/*           (pour le conditionnement ) */


/*     ARGUMENTS DE SORTIE : */
/*     --------------------- */

/*       IERCOD : Code d'erreur : 0 : O.K. */
/*                                1 : LES valeur de DEBFIN */
/*                                ne sont pas raisonnables */
/*                                -1 : L'init etait deja faite */
/*                                   (OK mais pas de traitement) */

/*     COMMONS UTILISES : */
/*     ------------------ */

/*     REFERENCES APPELEES   : */
/*     ---------------------- */
/*     Type  Name */

/*     DESCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */

/*        Ce programme initialise les coefficients des polynomes */
/*     d'Hermite qui sont ensuite lus par MMHERM1 */

/*     HISTORIQUE */
/*     --------------------------------------------------------- */
/*     06-01-92: ALR; mise a 0 des termes de MAT non recalcules */
/*     23-12-91: ALR; 2 CORRECTIONS */
/*     12-11-91: ALR; ECRITURE VERSION ORIGINALE. */
/* > */
/* ***********************************************************************
 */




/*     INCLUDE MMCMHER */
/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ********************************************************************** 
*/

/*     FONCTION : */
/*     ---------- */
/*      Sert a STOCKER les coefficients des polynomes de */
/*      l'interpolation d'Hermite */

/*     MOTS CLES : */
/*     ----------- */
/*      HERMITE */

/*     DEMSCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */

/*     les coefficients des polynomes d'hermitesont calcules par */
/*     la routine MMHERM0 et lus par la routine MMHERM1 */

/* $    HISTORIQUE DES MODIFICATIONS : */
/*     ------------------------------ */
/*     23-11-91: ALR; MODIF DIMENSIONNEMENT */
/*     12-11-91: ALR; CREATION */
/* > */
/* ********************************************************************** 
*/





/*     NBCOEF est la taille de CMHERM (voir plus bas) */



/* ***********************************************************************
 */







/* ***********************************************************************
 */
/*     Verification des donnees */
/* ***********************************************************************
 */


    /* Parameter adjustments */
    --debfin;

    /* Function Body */
    d1 = abs(debfin[1]);
    if (d1 > (float)100.) {
	goto L9101;
    }

    d2 = abs(debfin[2]);
    if (d2 > (float)100.) {
	goto L9101;
    }

    d2 = d1 + d2;
    if (d2 < (float).01) {
	goto L9101;
    }

    d1 = (d__1 = debfin[2] - debfin[1], abs(d__1));
    if (d1 / d2 < (float).01) {
	goto L9101;
    }


/* ***********************************************************************
 */
/*     Initialisations */
/* ***********************************************************************
 */

    *iercod = 0;

    epspi = 1e-10;


/* ***********************************************************************
 */

/*     EST-CE DEJA INITIALISE ? */

    d1 = abs(debfin[1]) + abs(debfin[2]);
    d1 *= 16111959;

    if (debfin[1] != mmcmher_1.tdebut) {
	goto L100;
    }
    if (debfin[2] != mmcmher_1.tfinal) {
	goto L100;
    }
    if (d1 != mmcmher_1.verifi) {
	goto L100;
    }


    goto L9001;


/* ***********************************************************************
 */
/*     CALCUL */
/* ***********************************************************************
 */


L100:

/*     Init. matrice identite: */

    ncmat = 36;
    mvriraz_(&ncmat, miden);

    for (ii = 1; ii <= 6; ++ii) {
	miden[ii + ii * 6 - 7] = 1.;
/* L110: */
    }



/*     Init a 0 du tableau CMHERM */

    mvriraz_(&c__576, mmcmher_1.cmherm);

/*     Calcul par resolution de systemes lineaires */

    for (iord1 = -1; iord1 <= 2; ++iord1) {
	for (iord2 = -1; iord2 <= 2; ++iord2) {

	    iord[0] = iord1;
	    iord[1] = iord2;


	    iof[0] = 0;
	    iof[1] = iord[0] + 1;


	    ncf = iord[0] + iord[1] + 2;

/*        Calcul matrice MAT a inverser: */

	    for (cot = 1; cot <= 2; ++cot) {


		if (iord[cot - 1] > -1) {
		    prod = 1.;
		    i__1 = ncf;
		    for (jj = 1; jj <= i__1; ++jj) {
			cof[jj - 1] = 1.;
/* L200: */
		    }
		}

		i__1 = iord[cot - 1] + 1;
		for (pp = 1; pp <= i__1; ++pp) {

		    ii = pp + iof[cot - 1];

		    prod = 1.;

		    i__2 = pp - 1;
		    for (jj = 1; jj <= i__2; ++jj) {
			mat[ii + jj * 6 - 7] = (float)0.;
/* L300: */
		    }

		    i__2 = ncf;
		    for (jj = pp; jj <= i__2; ++jj) {

/*        tout se passe dans ces 3 lignes peu lisibles
 */

			mat[ii + jj * 6 - 7] = cof[jj - 1] * prod;
			cof[jj - 1] *= jj - pp;
			prod *= debfin[cot];

/* L400: */
		    }
/* L500: */
		}

/* L1000: */
	    }

/*     Inversion */

	    if (ncf >= 1) {
		mmmrslwd_(&c__6, &ncf, &ncf, mat, miden, &epspi, abid, amat, &
			ier);
		if (ier > 0) {
		    goto L9101;
		}
	    }

	    for (cot = 1; cot <= 2; ++cot) {
		i__1 = iord[cot - 1] + 1;
		for (pp = 1; pp <= i__1; ++pp) {
		    i__2 = ncf;
		    for (ii = 1; ii <= i__2; ++ii) {
			mmcmher_1.cmherm[ii + (pp + (cot + ((iord1 + (iord2 << 
				2)) << 1)) * 3) * 6 + 155] = amat[ii + (pp + 
				iof[cot - 1]) * 6 - 7];
/* L1300: */
		    }
/* L1400: */
		}
/* L1500: */
	    }

/* L2000: */
	}
/* L2010: */
    }

/* ***********************************************************************
 */

/*     On positionne le flag initialise: */

    mmcmher_1.tdebut = debfin[1];
    mmcmher_1.tfinal = debfin[2];

    d1 = abs(debfin[1]) + abs(debfin[2]);
    mmcmher_1.verifi = d1 * 16111959;


/* ***********************************************************************
 */

    goto L9999;

/* ***********************************************************************
 */

L9101:
    *iercod = 1;
    goto L9999;

L9001:
    *iercod = -1;
    goto L9999;

/* ***********************************************************************
 */

L9999:

    maermsg_("MMHERM0", iercod, 7L);

/* ***********************************************************************
 */
 return 0 ;
} /* mmherm0_ */

