/* MPOCVI.f -- translated by f2c (version 19960827).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "Data_f2c.h"
#ifdef WNT
#include <MathBase.h>
#else 
#define  __MathBase_API
#endif
/* Subroutine */ __MathBase_API int mmpocvi_(ncofmx, ndegre, ndimen, courbe, uparam, somxmx, 
	difxmx)
integer *ncofmx, *ndegre, *ndimen;
doublereal *courbe, *uparam, *somxmx, *difxmx;
{
    /* System generated locals */
    integer courbe_dim1, courbe_offset, i__1;
    doublereal d__1;

    /* Local variables */
    static integer i__;
    static doublereal x;
    static integer ndegm, ndegp, nd;
    static doublereal bid;



/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*        Calcule C(x) et C(-x) et retourne 2 vecteurs */
/*        C(x)+C(-x) et C(x)-C(-x) */

/*     MOTS CLES : */
/*     ----------- */
/*     TOUS,AB_SPECIFI:: COURBE&,POSITIONNEMENT,SOMME,&POINT */

/*     ARGUMENTS D'ENTREE : */
/*     ------------------ */
/*   NCOFMX : Degre maximal +1 des courbes et carreaux. */
/*   NDEGRE   : Degre vrai de la courbe. */
/*   NDIMEN   : Dimension de l'espace (2 ou 3 en general) */

/*     ARGUMENTS DE SORTIE : */
/*     ------------------- */
/*   UPARAM : Le parametre ou l' on calcule C(x) et C(-x). */
/*   SOMXMX  : C(x)+C(-x) */
/*   DIFXMX  : C(x)-C(-x) */

/*     COMMONS UTILISES   : */
/*     ---------------- */

/*     REFERENCES APPELEES   : */
/*     ----------------------- */

/*     DESCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */

/* $    HISTORIQUE DES MODIFICATIONS   : */
/*     -------------------------------- */
/*     12-04-1989 : RBD ; Appel MGSOMSG. */
/*     10-06-1988 : JJM ; Creation. */

/* > */
/* ***********************************************************************
 */


    /* Parameter adjustments */
    --difxmx;
    --somxmx;
    courbe_dim1 = *ncofmx;
    courbe_offset = courbe_dim1;
    courbe -= courbe_offset;

    /* Function Body */
/* Computing 2nd power */
    d__1 = *uparam;
    x = d__1 * d__1;
    ndegp = *ndegre / 2 << 1;
    ndegm = ((*ndegre - 1) / 2 << 1) + 1;
    i__1 = *ndimen;
    for (nd = 1; nd <= i__1; ++nd) {
	bid = courbe[ndegp + nd * courbe_dim1];
	for (i__ = ndegp - 2; i__ >= 0; i__ += -2) {
	    bid = bid * x + courbe[i__ + nd * courbe_dim1];
/* L120: */
	}
	somxmx[nd] = bid * 2.;

	bid = courbe[ndegm + nd * courbe_dim1];
	for (i__ = ndegm - 2; i__ >= 0; i__ += -2) {
	    bid = bid * x + courbe[i__ + nd * courbe_dim1];
/* L130: */
	}
	difxmx[nd] = *uparam * 2. * bid;
/* L300: */
    }

    return 0;
} /* mmpocvi_ */

