/* AOVERF.f -- translated by f2c (version 19960827).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "Data_f2c.h"
#include <Data_Data.h>
/* Common Block Declarations */

/*extern __Data_API struct {*/
extern struct {
    doublereal r8und, r8ovr, x4und, x4ovr;
    real r4und, r4ovr;
    integer r4nbe, r8nbm, r8nbe, i4ovr, i4ovn, r4exp, r8exp, r4exn, r8exn, 
	    r4ncs, r8ncs, r4nbm;
    shortint i2ovr, i2ovn;
} maovpar_;

#define maovpar_1 maovpar_

extern struct {
    char cnmmac[16], frmr4[8], frmr8[8], cdcode[8];
} maovpch_;

#define maovpch_1 maovpch_

/* Subroutine */ int maoverf_(nbentr, dtable)
integer *nbentr;
doublereal *dtable;
{
    /* Initialized data */

    static integer ifois = 0;

    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    double log();

    /* Local variables */
    static integer ibid;
    static doublereal buff[63];
    static integer ioct, indic, nrest, icompt;
    extern /* Subroutine */ int mcrfill_();



/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*       Initialisation en overflow d'un tableau en DOUBLE PRECISION */

/*     MOTS CLES : */
/*     ----------- */
/*       MANIPULATION, MEMOIRE, INITIALISATION, OVERFLOW */

/*     ARGUMENTS D'ENTREE : */
/*     -------------------- */
/*       NBENTR : Nombre d'entrees du tableau */

/*     ARGUMENTS DE SORTIE : */
/*     --------------------- */
/*       DATBLE : Tableau double precision initialise en overflow */

/*     COMMONS UTILISES : */
/*     ------------------ */
/*       R8OVR contenu dans l'include MAOVPAR.INC */

/*     REFERENCES APPELEES : */
/*     --------------------- */
/*       MCRFILL */

/*     DESCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */
/*       1) Doc. programmeur : */

/*       Cette routine initialise a l'overflow positif un tableau en */
/*       DOUBLE PRECISION. */

/*       Les autres types de tableaux (INTEGER*2, INTEGER, REAL, ...) */
/*       ne sont pas geres par la routine. */

/*       Elle est utilisable en phase de developpement pour deceler les */
/*       erreurs d'initialisation. */

/*       En version officielle, ses appels seront desactives. */

/*       ACCES : Sur accord avec AC. */

/*       La routine ne renvoie pas de code d'erreur. */

/*       L'argument NBELEM doit etre positif. */
/*       S'il est negatif ou nul, affichage du message "MAOVERF : NBELEM =
 */
/*       valeur_de_NBELEM" et d'un Trace Back par l'appel a la routine */
/*       MAOSTRB. */


/*       2) Doc. concepteur : */

/*                  L'idee est de minimiser le nombre d'appels a */
/*                la routine de transfert de zones numeriques, */
/*   ----------   pour des raisons de performances. */
/*  !  buffer  !    Pour cela, on se reserve un tableau de NLONGR */
/*  !__________!  DOUBLE PRECISIONs. Ce buffer est initialise par */
/*  <---------->  l'instruction DATA. L'overflow est accede dans un */
/*    NLONGR*8    COMMON specifique et non par une routine car */
/*                l'initialisation se fait par DATA. */

/*                * Si NBENTR<NLONGR, une partie du buffer est transferee 
*/
/*     DTABLE     dans DTABLE. */
/*   __________ */
/*  !  amorce  !  * Sinon, tout le buffer est transfere dans DTABLE. */
/*  !__________!  C'est l'amorce. Puis on execute une boucle qui a chaque 
*/
/*  !  temps 1 !  iteration transfere la partie du tableau deja */
/*  !__________!  initialisee dans celle qui ne l'a pas encore ete. La */
/*  !          !  taille de la zone transferee par chaque appel a MCRFILL 
*/
/*  !  temps 2 !  est donc de NLONGR*2**(numero_de_l'iteration). Lorsque 
*/
/*  !          !  la taille du tableau restant a initialiser est */
/*  !__________!  inferieure a celle deja initialisee, on sort de la */
/*  !          !  boucle et un dernier transfert est effectue pour */
/*  !          !  initialiser le reste du tableau, sauf si la taille */
/*  !          !  du tableau est du type NLONGR*2**K. */
/*  !  temps 3 ! */
/*  !          !  * NLONGR sera egal a 19200. */
/*  !          ! */
/*  !          ! */
/*  !__________! */
/*  !  reste   ! */
/*  !__________! */

/* $    HISTORIQUE DES MODIFICATIONS : */
/*     ------------------------------ */
/*     05-03-93 : JMB ; Prise en compte MAOVPAR non specifique */
/*     02-10-91 : DGZ ; Reprise et livraison */
/*     17-08-90 : EVT ; Creation version originale. */
/* > */
/* ***********************************************************************
 */

/* Inclusion de MAOVPAR.INC */

/*      CONSTANTES */
/*     INCLUDE MAOVPAR */


/* < */
/* **NOTICE */
/*  THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH. */
/*  THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR */
/*  WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE */
/*  SITE WHERE IT IS INSTALLED BY CISIGRAPH */
/* **NOTICE */

/* ***********************************************************************
 */

/*     FONCTION : */
/*     ---------- */
/*       DEFINIT LES VALEURS LIMITES SPECIFIQUES MACHINE. */

/*     MOTS CLES : */
/*     ----------- */
/*       SYSTEME, LIMITES, VALEURS, SPECIFIQUE */

/*     DEMSCRIPTION/REMARQUES/LIMITATIONS : */
/*     ----------------------------------- */
/*     *** ELLES NE PEUVENT PAS ETRE ECRASEES EN COURS D'EXECUTION. */

/*     *** LES VALEURS D'UNDERFLOW ET D'OVERFLOW NE PEUVENT PAS ETRE */
/*     DEFINIES EN VALEUR DECIMALES (ERREUR A LA COMPILATION D_FLOAT) */
/*     ON LES DEFINIT DONC EN VALEUR HEXADECIMALES */

/* $    HISTORIQUE DES MODIFICATIONS : */
/*     ------------------------------ */
/*     02-02-1993 : JMB ; SUPPRESSION DE LA SPECIFICITE DE L'INCLUDE */
/*     29-08-1990 : DGZ ; AJOUT DES REELS X4OVR ET X4UND */
/*     10-08-1990 : DGZ ; AJOUT DES FORMATS FRMR4,FRMR8,FRMR8G */
/*     18-06-1990 : CS/DGZ ; CREATION VERSION ORIGINALE */
/* > */
/* ***********************************************************************
 */


/*    DECLARATION DU COMMON POUR LES TYPES NUMERIQUES */


/*    DECLARATION DU COMMON POUR LES TYPES CARACTERES */



/*      VARIABLES LOCALES */

/*      TABLEAUX */

/*      DATAS */
    /* Parameter adjustments */
    --dtable;

    /* Function Body */

/* vJMB R8OVR n est pas encore initialise, donc impossible d utiliser DATA
 */
/*         DATA BUFF / NLONGR * R8OVR / */

/*    l init de BUFF n est faite qu'une fois */

    if (ifois == 0) {
	for (icompt = 1; icompt <= 63; ++icompt) {
	    buff[icompt - 1] = maovpar_1.r8ovr;
/* L20: */
	}
	ifois = 1;
    }

/* ^JMB */
/* Exception */
    if (*nbentr < 63) {
	nrest = *nbentr << 3;
	mcrfill_(&nrest, buff, &dtable[1]);
    } else {

/* Amorce & initialisations */
	ioct = 504;
	mcrfill_(&ioct, buff, &dtable[1]);
	indic = 63;

/* Boucle. La borne sup. est la valeur entiere du logarithme de base 2
 */
/* de NBENTR/NLONGR. */
	i__1 = (integer) (log((real) (*nbentr) / (float)63.) / log((float)2.))
		;
	for (ibid = 1; ibid <= i__1; ++ibid) {

	    mcrfill_(&ioct, &dtable[1], &dtable[indic + 1]);
	    ioct += ioct;
	    indic += indic;

/* L10: */
	}

	nrest = ( *nbentr - indic ) << 3;

	if (nrest > 0) {
	    mcrfill_(&nrest, &dtable[1], &dtable[indic + 1]);
	}

    }
 return 0 ;
} /* maoverf_ */

