/*........................................................................*/
/*** NOTICE                                                               */
/*   THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH.                          */
/*   THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR        */
/*   WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE        */
/*   SITE WHERE IT IS INSTALLED BY CISIGRAPH.                             */
/*** NOTICE                                                               */
/*........................................................................*/
/*                                                                        */
/*   FONCTION :                                                           */
/*   ----------                                                           */
/*               Routines de gestion de la memoire dynamique.             */
/*                                                                        */
/*             Routine mcrfree                                             */
/*             --------------                                             */
/*                                                                        */
/*             Desallocation d'une zone memoire.                          */
/*                                                                        */
/*             CALL MCRFREE (IBYTE,IADR,IER)                               */
/*                                                                        */
/*             IBYTE INTEGER*4 : Nombre d'Octetes a Liberer               */
/*                                                                        */
/*             IADR POINTEUR   : Adresse de Depart                        */
/*                                                                        */
/*             IER  INTEGER*4  : Code de Retour                           */
/*                                                                        */
/*                                                                        */
/*   MOTS CLES :                                                          */
/*   -----------                                                          */
/*                                                                        */
/*   ARGUMENTS D'ENTREE :                                                 */
/*   --------------------                                                 */
/*                                                                        */
/*   ARGUMENTS DE SORTIE :                                                */
/*   ---------------------                                                */
/*                                                                        */
/*   COMMONS UTILISES :                                                   */
/*   ------------------                                                   */
/*                                                                        */
/*   REFERENCES APPELEES :                                                */
/*   ---------------------                                                */
/*                                                                        */
/*   DEMSCRIPTION/REMARQUES/LIMITATIONS :                                  */
/*   -----------------------------------                                  */
/*                                                                        */
/*                      ** SPECIFIQUE SPS9 **                             */
/*                                                                        */
/*                                                                        */
/*   HISTORIQUE DES MODIFICATIONS :                                       */
/*   ------------------------------                                       */
/*                                                                        */
/*   07-03-86 : FS; INSERTION DE L'ENTETE STANDARD C                      */
/*   16-09-86 : FS; MODIFICATIONS PASSAGE NIVEAU INFERIEUR                */
/* SGI_H 05-04-90 : ACT ; ECLATEMENT DU PACKAGE CRALOC                    */
/*                                                                        */
/*........................................................................*/
/*                                                                        */
#include <Data_f2c.h>
void mcrfree_(ibyte,iadr,ier)
integer *ibyte,*ier;
uinteger *iadr;
{
  void free();
  *ier=0;
  free(*iadr);
  if ( !*iadr ) *ier = 1;
}
