/*........................................................................*/
/*** NOTICE                                                               */
/*   THIS SOFTWARE IS THE PROPERTY OF CISIGRAPH.                          */
/*   THIS CODE MUST NOT BE DISTRIBUTED OR COPIED WITHOUT THE PRIOR        */
/*   WRITTEN PERMISSION OF CISIGRAPH AND IS ONLY TO BE USED ON THE        */
/*   SITE WHERE IT IS INSTALLED BY CISIGRAPH.                             */
/*** NOTICE                                                               */
/*........................................................................*/
/*                                                                        */
/*   FONCTION :                                                           */
/*   ----------                                                           */
/*               Routines de gestion de la memoire dynamique.             */
/*                                                                        */
/*             Routine mcrgetv                                             */
/*             --------------                                             */
/*                                                                        */
/*               Demande d'allocation de memoire.                         */
/*                                                                        */
/*               CALL MCRGETV(IBYTE,IADR,IER)                              */
/*                                                                        */
/*               IBYTE (INTEGER*4) Nombre de Bytes d'allocation           */
/*                                 demandee                               */    
/*                                                                        */
/*               IADR   (INTEGER*4) : Resultat.                           */
/*                                                                        */
/*               IER (INTEGER*4)    : Code d'erreur :                     */
/*                                                                        */
/*                   = 0  ==> OK                                          */
/*                   = 1  ==> Allocation impossible                       */
/*                   = -1 ==> Ofset > 2**31 - 1                           */
/*                                                                        */
/*   MOTS CLES :                                                          */
/*   -----------                                                          */
/*                                                                        */
/*   ARGUMENTS D'ENTREE :                                                 */
/*   --------------------                                                 */
/*                                                                        */
/*   ARGUMENTS DE SORTIE :                                                */
/*   ---------------------                                                */
/*                                                                        */
/*   COMMONS UTILISES :                                                   */
/*   ------------------                                                   */
/*                                                                        */
/*   REFERENCES APPELEES :                                                */
/*   ---------------------                                                */
/*                                                                        */
/*   DEMSCRIPTION/REMARQUES/LIMITATIONS :                                  */
/*   -----------------------------------                                  */
/*                                                                        */
/*                      ** SPECIFIQUE SPS9 **                             */
/*                                                                        */
/*                                                                        */
/*   HISTORIQUE DES MODIFICATIONS :                                       */
/*   ------------------------------                                       */
/*                                                                        */
/*   07-03-86 : FS; INSERTION DE L'ENTETE STANDARD C                      */
/*   16-09-86 : FS; MODIFICATIONS PASSAGE NIVEAU INFERIEUR                */
/*SGI_H 05-04-90 : ACT ; ECLATEMENT DU PACKAGE CRALOC                     */
/*                                                                        */
/*........................................................................*/
/*                                                                        */
#include <Data_f2c.h>
void mcrgetv_(sz,iad,ier)
uinteger *iad;
integer *sz;
integer *ier;
{
  uinteger malloc();
  *ier = 0;
  *iad = malloc(*sz);
  if ( !*iad ) *ier = 1;
}

